module.exports = {"id":"index","paths":{"relative":"index.md","project":"docs/index.md","projectRequire":"docs/index.md","absolute":"/Users/jonathan/Skypager/packages/skypager-project/test/fixture/docs/index.md"},"assetGroup":"documents","fingerprint":"05d36b3d4dee761abfba012e21dcee04","markdown":"---\nauthor: Jonathan Soeder\ntype: testcase\n---\n\n# Skypager.js\n\nWelcome to the documentation and test suite for Skypager which I\nlike to call the cloud writing framework.  Skypager makes it easy to\nbuild data driven reactive websites on top of the many forms of constantly\nevolving streams of communication that humans engage in on the internet.\n\nA Skypager project contains writing about certain abstract set of Things, or more formally Entities.  These entities usually exist in or are referred to by some other document, system, or external API.  A lot of the time these Entities may change over time.  \n\nSkypager provides an easy way for building functionality around these entities and their relationships to each other, and to incorporate other knowledge data related to these Entities in that exist in other systems.\n\n## Setup\n\nIf you are reading this page, this has been generated by Skypager.  It\nconsists of individual markdown files that correspond to important areas\nof the project's internals.  These markdown files follow a particular\nstructure with respect to the headings they use. This allows us to parse\ntheir contents and use them to build more dynamic and interactive web\ncontent than we would be able to with just traditional markdown. \n\nThis documentation is both API documentation for the project and runnable test code.\n\n## Specifications\n\n### Skypager Projects can be required like any common.js document \n\n```javascript\nproject.should.have.property('uri')\nproject.should.have.property('dirname', 'documentation')\n```\n\n### Skypager reads a collection of files and turns them into javascript \n\nSkypager projects have a special structure.  Different folders are used to store different types of files which serve a different purpose. \n\n#### Assets\n\nWe start with the project assets themselves which would be anything from markdown documents, static data sources in JSON, SVG Diagrams, excel spreadsheets: anything which can be read and parsed and turned into javascript data. \n\n```javascript\nproject.paths.should.have.property('assets')\nproject.paths.should.have.property('documents')\nproject.paths.should.have.property('data_sources')\n```\n\nThese assets are available to the project as content which can be\ndirectly rendered on a website, in the most simplest case.  \n\n```javascript\nproject.content.documents.should.have.property('assets')\nproject.content.assets.should.have.property('assets')\nproject.content.data_sources.should.have.property('assets')\n```\n\nHowever it is when we parse these things and use them to power our entity models, that we can do really interesting things with them.  The helper system allows us to define the way this content can be used to power these kinds of applications. \n\n#### Helpers\n\nHelpers are different types of javascript files which an be used to\nextend the functionality of a Skypager Project, control how it is\nrendered, how it can observe or interact with the outside world to keep\nthe different Entities referred to in the project in sync. \n\nA project can include its own custom helpers directly.\n\n```javascript\nproject.paths.should.have.property('actions')\nproject.paths.should.have.property('exporters')\nproject.paths.should.have.property('importers')\nproject.paths.should.have.property('models')\nproject.paths.should.have.property('plugins')\nproject.paths.should.have.property('renderers')\n```\n### Skypager ships with a few of its own helpers\n\nSkypager also ships with a bunch of its own helpers for common use cases.\n\nUsing helpers internally is a clean way of organizing the many different\nparts of our code base.\n\n```javascript\nskypager.helpers.exporters.assets.should.not.have.property('length',0)\nskypager.helpers.importers.assets.should.not.have.property('length',0)\nskypager.helpers.models.assets.should.not.have.property('length',0)\nskypager.helpers.renderers.assets.should.not.have.property('length',0)\n```\n\n### Skypager ships with a few of its own plugins.\n\n```javascript\nskypager.helpers.plugins.should.have.property('assets')\nskypager.helpers.plugins.assets.should.not.have.property('length',0)\n```\n\nThese can be used by any project, and provide additional helpers.\n\n\n","ast":{"type":"root","children":[{"type":"yaml","value":"author: Jonathan Soeder\ntype: testcase","position":{"start":{"line":1,"column":1},"end":{"line":4,"column":4},"indent":[1,1,1]},"index":0,"depth":1,"parentId":"index","childIndex":0,"childId":"yaml-1-1","id":"index-yaml-1-1","data":{"htmlAttributes":{"data-node-index":0}}},{"type":"heading","depth":1,"children":[{"type":"text","value":"Skypager.js","position":{"start":{"line":6,"column":3},"end":{"line":6,"column":14},"indent":[]}}],"position":{"start":{"line":6,"column":1},"end":{"line":6,"column":14},"indent":[]},"index":1,"data":{"htmlAttributes":{"id":"skypagerjs","data-node-index":1}},"id":"skypagerjs","value":"Skypager.js","parentId":"index"},{"type":"paragraph","children":[{"type":"text","value":"Welcome to the documentation and test suite for Skypager which I\nlike to call the cloud writing framework.  Skypager makes it easy to\nbuild data driven reactive websites on top of the many forms of constantly\nevolving streams of communication that humans engage in on the internet.","position":{"start":{"line":8,"column":1},"end":{"line":11,"column":73},"indent":[1,1,1]}}],"position":{"start":{"line":8,"column":1},"end":{"line":11,"column":73},"indent":[1,1,1]},"index":2,"depth":1,"parentId":"skypagerjs","childIndex":0,"childId":"p-1-1","id":"skypagerjs-p-1-1","data":{"htmlAttributes":{"data-node-index":2}}},{"type":"paragraph","children":[{"type":"text","value":"A Skypager project contains writing about certain abstract set of Things, or more formally Entities.  These entities usually exist in or are referred to by some other document, system, or external API.  A lot of the time these Entities may change over time.  ","position":{"start":{"line":13,"column":1},"end":{"line":13,"column":260},"indent":[]}}],"position":{"start":{"line":13,"column":1},"end":{"line":13,"column":260},"indent":[]},"index":3,"depth":1,"parentId":"skypagerjs","childIndex":1,"childId":"p-1-2","id":"skypagerjs-p-1-2","data":{"htmlAttributes":{"data-node-index":3}}},{"type":"paragraph","children":[{"type":"text","value":"Skypager provides an easy way for building functionality around these entities and their relationships to each other, and to incorporate other knowledge data related to these Entities in that exist in other systems.","position":{"start":{"line":15,"column":1},"end":{"line":15,"column":216},"indent":[]}}],"position":{"start":{"line":15,"column":1},"end":{"line":15,"column":216},"indent":[]},"index":4,"depth":1,"parentId":"skypagerjs","childIndex":2,"childId":"p-1-3","id":"skypagerjs-p-1-3","data":{"htmlAttributes":{"data-node-index":4}}},{"type":"section","depth":2,"children":[{"type":"heading","depth":2,"children":[{"type":"text","value":"Setup","position":{"start":{"line":17,"column":4},"end":{"line":17,"column":9},"indent":[]}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":9},"indent":[]},"index":5,"data":{"htmlAttributes":{"id":"setup"}},"id":"setup","value":"Setup","parentId":"skypagerjs"},{"type":"paragraph","children":[{"type":"text","value":"If you are reading this page, this has been generated by Skypager.  It\nconsists of individual markdown files that correspond to important areas\nof the project's internals.  These markdown files follow a particular\nstructure with respect to the headings they use. This allows us to parse\ntheir contents and use them to build more dynamic and interactive web\ncontent than we would be able to with just traditional markdown. ","position":{"start":{"line":19,"column":1},"end":{"line":24,"column":66},"indent":[1,1,1,1,1]}}],"position":{"start":{"line":19,"column":1},"end":{"line":24,"column":66},"indent":[1,1,1,1,1]},"index":6,"depth":2,"parentId":"setup","childIndex":0,"childId":"p-2-1","id":"setup-p-2-1","data":{"htmlAttributes":{"data-node-index":6}}},{"type":"paragraph","children":[{"type":"text","value":"This documentation is both API documentation for the project and runnable test code.","position":{"start":{"line":26,"column":1},"end":{"line":26,"column":85},"indent":[]}}],"position":{"start":{"line":26,"column":1},"end":{"line":26,"column":85},"indent":[]},"index":7,"depth":2,"parentId":"setup","childIndex":1,"childId":"p-2-2","id":"setup-p-2-2","data":{"htmlAttributes":{"data-node-index":7}}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":9},"indent":[]},"index":5,"data":{"htmlName":"section","htmlAttributes":{"class":"depth-2 sections","id":"setup","data-node-index":5}},"id":"setup","value":"Setup","parentId":"skypagerjs"},{"type":"paragraph","children":[{"type":"text","value":"If you are reading this page, this has been generated by Skypager.  It\nconsists of individual markdown files that correspond to important areas\nof the project's internals.  These markdown files follow a particular\nstructure with respect to the headings they use. This allows us to parse\ntheir contents and use them to build more dynamic and interactive web\ncontent than we would be able to with just traditional markdown. ","position":{"start":{"line":19,"column":1},"end":{"line":24,"column":66},"indent":[1,1,1,1,1]}}],"position":{"start":{"line":19,"column":1},"end":{"line":24,"column":66},"indent":[1,1,1,1,1]},"index":6,"depth":2,"parentId":"setup","childIndex":0,"childId":"p-2-1","id":"setup-p-2-1","data":{"htmlAttributes":{"data-node-index":6}}},{"type":"paragraph","children":[{"type":"text","value":"This documentation is both API documentation for the project and runnable test code.","position":{"start":{"line":26,"column":1},"end":{"line":26,"column":85},"indent":[]}}],"position":{"start":{"line":26,"column":1},"end":{"line":26,"column":85},"indent":[]},"index":7,"depth":2,"parentId":"setup","childIndex":1,"childId":"p-2-2","id":"setup-p-2-2","data":{"htmlAttributes":{"data-node-index":7}}},{"type":"section","depth":2,"children":[{"type":"heading","depth":2,"children":[{"type":"text","value":"Specifications","position":{"start":{"line":28,"column":4},"end":{"line":28,"column":18},"indent":[]}}],"position":{"start":{"line":28,"column":1},"end":{"line":28,"column":18},"indent":[]},"index":8,"data":{"htmlAttributes":{"id":"specifications"}},"id":"specifications","value":"Specifications","parentId":"skypagerjs"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager Projects can be required like any common.js document","position":{"start":{"line":30,"column":5},"end":{"line":30,"column":66},"indent":[]}}],"position":{"start":{"line":30,"column":1},"end":{"line":30,"column":67},"indent":[]},"index":9,"data":{"htmlAttributes":{"id":"skypager-projects-can-be-required-like-any-commonjs-document"}},"id":"skypager-projects-can-be-required-like-any-commonjs-document","value":"Skypager Projects can be required like any common.js document","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.should.have.property('uri')\nproject.should.have.property('dirname', 'documentation')","position":{"start":{"line":32,"column":1},"end":{"line":35,"column":4},"indent":[1,1,1]},"index":10,"depth":3,"parentId":"skypager-projects-can-be-required-like-any-commonjs-document","childIndex":0,"childId":"code-3-1","id":"skypager-projects-can-be-required-like-any-commonjs-document-code-3-1","data":{"htmlAttributes":{"data-node-index":10}}}],"position":{"start":{"line":30,"column":1},"end":{"line":30,"column":67},"indent":[]},"index":9,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-projects-can-be-required-like-any-commonjs-document","data-node-index":9}},"id":"skypager-projects-can-be-required-like-any-commonjs-document","value":"Skypager Projects can be required like any common.js document","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager reads a collection of files and turns them into javascript","position":{"start":{"line":37,"column":5},"end":{"line":37,"column":72},"indent":[]}}],"position":{"start":{"line":37,"column":1},"end":{"line":37,"column":73},"indent":[]},"index":11,"data":{"htmlAttributes":{"id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"}},"id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript","value":"Skypager reads a collection of files and turns them into javascript","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"Skypager projects have a special structure.  Different folders are used to store different types of files which serve a different purpose. ","position":{"start":{"line":39,"column":1},"end":{"line":39,"column":140},"indent":[]}}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":140},"indent":[]},"index":12,"depth":3,"parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript","childIndex":0,"childId":"p-3-1","id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript-p-3-1","data":{"htmlAttributes":{"data-node-index":12}}},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Assets","position":{"start":{"line":41,"column":6},"end":{"line":41,"column":12},"indent":[]}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":12},"indent":[]},"index":13,"data":{"htmlAttributes":{"id":"assets"}},"id":"assets","value":"Assets","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"paragraph","children":[{"type":"text","value":"We start with the project assets themselves which would be anything from markdown documents, static data sources in JSON, SVG Diagrams, excel spreadsheets: anything which can be read and parsed and turned into javascript data. ","position":{"start":{"line":43,"column":1},"end":{"line":43,"column":228},"indent":[]}}],"position":{"start":{"line":43,"column":1},"end":{"line":43,"column":228},"indent":[]},"index":14,"depth":4,"parentId":"assets","childIndex":0,"childId":"p-4-1","id":"assets-p-4-1","data":{"htmlAttributes":{"data-node-index":14}}},{"type":"code","lang":"javascript","value":"project.paths.should.have.property('assets')\nproject.paths.should.have.property('documents')\nproject.paths.should.have.property('data_sources')","position":{"start":{"line":45,"column":1},"end":{"line":49,"column":4},"indent":[1,1,1,1]},"index":15,"depth":4,"parentId":"assets","childIndex":1,"childId":"code-4-2","id":"assets-code-4-2","data":{"htmlAttributes":{"data-node-index":15}}},{"type":"paragraph","children":[{"type":"text","value":"These assets are available to the project as content which can be\ndirectly rendered on a website, in the most simplest case.  ","position":{"start":{"line":51,"column":1},"end":{"line":52,"column":61},"indent":[1]}}],"position":{"start":{"line":51,"column":1},"end":{"line":52,"column":61},"indent":[1]},"index":16,"depth":4,"parentId":"assets","childIndex":2,"childId":"p-4-3","id":"assets-p-4-3","data":{"htmlAttributes":{"data-node-index":16}}},{"type":"code","lang":"javascript","value":"project.content.documents.should.have.property('assets')\nproject.content.assets.should.have.property('assets')\nproject.content.data_sources.should.have.property('assets')","position":{"start":{"line":54,"column":1},"end":{"line":58,"column":4},"indent":[1,1,1,1]},"index":17,"depth":4,"parentId":"assets","childIndex":3,"childId":"code-4-4","id":"assets-code-4-4","data":{"htmlAttributes":{"data-node-index":17}}},{"type":"paragraph","children":[{"type":"text","value":"However it is when we parse these things and use them to power our entity models, that we can do really interesting things with them.  The helper system allows us to define the way this content can be used to power these kinds of applications. ","position":{"start":{"line":60,"column":1},"end":{"line":60,"column":245},"indent":[]}}],"position":{"start":{"line":60,"column":1},"end":{"line":60,"column":245},"indent":[]},"index":18,"depth":4,"parentId":"assets","childIndex":4,"childId":"p-4-5","id":"assets-p-4-5","data":{"htmlAttributes":{"data-node-index":18}}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":12},"indent":[]},"index":13,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"assets","data-node-index":13}},"id":"assets","value":"Assets","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Helpers","position":{"start":{"line":62,"column":6},"end":{"line":62,"column":13},"indent":[]}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":13},"indent":[]},"index":19,"data":{"htmlAttributes":{"id":"helpers"}},"id":"helpers","value":"Helpers","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"paragraph","children":[{"type":"text","value":"Helpers are different types of javascript files which an be used to\nextend the functionality of a Skypager Project, control how it is\nrendered, how it can observe or interact with the outside world to keep\nthe different Entities referred to in the project in sync. ","position":{"start":{"line":64,"column":1},"end":{"line":67,"column":60},"indent":[1,1,1]}}],"position":{"start":{"line":64,"column":1},"end":{"line":67,"column":60},"indent":[1,1,1]},"index":20,"depth":4,"parentId":"helpers","childIndex":0,"childId":"p-4-1","id":"helpers-p-4-1","data":{"htmlAttributes":{"data-node-index":20}}},{"type":"paragraph","children":[{"type":"text","value":"A project can include its own custom helpers directly.","position":{"start":{"line":69,"column":1},"end":{"line":69,"column":55},"indent":[]}}],"position":{"start":{"line":69,"column":1},"end":{"line":69,"column":55},"indent":[]},"index":21,"depth":4,"parentId":"helpers","childIndex":1,"childId":"p-4-2","id":"helpers-p-4-2","data":{"htmlAttributes":{"data-node-index":21}}},{"type":"code","lang":"javascript","value":"project.paths.should.have.property('actions')\nproject.paths.should.have.property('exporters')\nproject.paths.should.have.property('importers')\nproject.paths.should.have.property('models')\nproject.paths.should.have.property('plugins')\nproject.paths.should.have.property('renderers')","position":{"start":{"line":71,"column":1},"end":{"line":78,"column":4},"indent":[1,1,1,1,1,1,1]},"index":22,"depth":4,"parentId":"helpers","childIndex":2,"childId":"code-4-3","id":"helpers-code-4-3","data":{"htmlAttributes":{"data-node-index":22}}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":13},"indent":[]},"index":19,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"helpers","data-node-index":19}},"id":"helpers","value":"Helpers","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"}],"position":{"start":{"line":37,"column":1},"end":{"line":37,"column":73},"indent":[]},"index":11,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript","data-node-index":11}},"id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript","value":"Skypager reads a collection of files and turns them into javascript","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager ships with a few of its own helpers","position":{"start":{"line":79,"column":5},"end":{"line":79,"column":49},"indent":[]}}],"position":{"start":{"line":79,"column":1},"end":{"line":79,"column":49},"indent":[]},"index":23,"data":{"htmlAttributes":{"id":"skypager-ships-with-a-few-of-its-own-helpers"}},"id":"skypager-ships-with-a-few-of-its-own-helpers","value":"Skypager ships with a few of its own helpers","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"Skypager also ships with a bunch of its own helpers for common use cases.","position":{"start":{"line":81,"column":1},"end":{"line":81,"column":74},"indent":[]}}],"position":{"start":{"line":81,"column":1},"end":{"line":81,"column":74},"indent":[]},"index":24,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-helpers","childIndex":0,"childId":"p-3-1","id":"skypager-ships-with-a-few-of-its-own-helpers-p-3-1","data":{"htmlAttributes":{"data-node-index":24}}},{"type":"paragraph","children":[{"type":"text","value":"Using helpers internally is a clean way of organizing the many different\nparts of our code base.","position":{"start":{"line":83,"column":1},"end":{"line":84,"column":24},"indent":[1]}}],"position":{"start":{"line":83,"column":1},"end":{"line":84,"column":24},"indent":[1]},"index":25,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-helpers","childIndex":1,"childId":"p-3-2","id":"skypager-ships-with-a-few-of-its-own-helpers-p-3-2","data":{"htmlAttributes":{"data-node-index":25}}},{"type":"code","lang":"javascript","value":"skypager.helpers.exporters.assets.should.not.have.property('length',0)\nskypager.helpers.importers.assets.should.not.have.property('length',0)\nskypager.helpers.models.assets.should.not.have.property('length',0)\nskypager.helpers.renderers.assets.should.not.have.property('length',0)","position":{"start":{"line":86,"column":1},"end":{"line":91,"column":4},"indent":[1,1,1,1,1]},"index":26,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-helpers","childIndex":2,"childId":"code-3-3","id":"skypager-ships-with-a-few-of-its-own-helpers-code-3-3","data":{"htmlAttributes":{"data-node-index":26}}}],"position":{"start":{"line":79,"column":1},"end":{"line":79,"column":49},"indent":[]},"index":23,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-ships-with-a-few-of-its-own-helpers","data-node-index":23}},"id":"skypager-ships-with-a-few-of-its-own-helpers","value":"Skypager ships with a few of its own helpers","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager ships with a few of its own plugins.","position":{"start":{"line":93,"column":5},"end":{"line":93,"column":50},"indent":[]}}],"position":{"start":{"line":93,"column":1},"end":{"line":93,"column":50},"indent":[]},"index":27,"data":{"htmlAttributes":{"id":"skypager-ships-with-a-few-of-its-own-plugins"}},"id":"skypager-ships-with-a-few-of-its-own-plugins","value":"Skypager ships with a few of its own plugins.","parentId":"specifications"},{"type":"code","lang":"javascript","value":"skypager.helpers.plugins.should.have.property('assets')\nskypager.helpers.plugins.assets.should.not.have.property('length',0)","position":{"start":{"line":95,"column":1},"end":{"line":98,"column":4},"indent":[1,1,1]},"index":28,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-plugins","childIndex":0,"childId":"code-3-1","id":"skypager-ships-with-a-few-of-its-own-plugins-code-3-1","data":{"htmlAttributes":{"data-node-index":28}}},{"type":"paragraph","children":[{"type":"text","value":"These can be used by any project, and provide additional helpers.","position":{"start":{"line":100,"column":1},"end":{"line":100,"column":66},"indent":[]}}],"position":{"start":{"line":100,"column":1},"end":{"line":100,"column":66},"indent":[]},"index":29,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-plugins","childIndex":1,"childId":"p-3-2","id":"skypager-ships-with-a-few-of-its-own-plugins-p-3-2","data":{"htmlAttributes":{"data-node-index":29}}}],"position":{"start":{"line":93,"column":1},"end":{"line":93,"column":50},"indent":[]},"index":27,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-ships-with-a-few-of-its-own-plugins","data-node-index":27}},"id":"skypager-ships-with-a-few-of-its-own-plugins","value":"Skypager ships with a few of its own plugins.","parentId":"specifications"}],"position":{"start":{"line":28,"column":1},"end":{"line":28,"column":18},"indent":[]},"index":8,"data":{"htmlName":"section","htmlAttributes":{"class":"depth-2 sections","id":"specifications","data-node-index":8}},"id":"specifications","value":"Specifications","parentId":"skypagerjs"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager Projects can be required like any common.js document","position":{"start":{"line":30,"column":5},"end":{"line":30,"column":66},"indent":[]}}],"position":{"start":{"line":30,"column":1},"end":{"line":30,"column":67},"indent":[]},"index":9,"data":{"htmlAttributes":{"id":"skypager-projects-can-be-required-like-any-commonjs-document"}},"id":"skypager-projects-can-be-required-like-any-commonjs-document","value":"Skypager Projects can be required like any common.js document","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.should.have.property('uri')\nproject.should.have.property('dirname', 'documentation')","position":{"start":{"line":32,"column":1},"end":{"line":35,"column":4},"indent":[1,1,1]},"index":10,"depth":3,"parentId":"skypager-projects-can-be-required-like-any-commonjs-document","childIndex":0,"childId":"code-3-1","id":"skypager-projects-can-be-required-like-any-commonjs-document-code-3-1","data":{"htmlAttributes":{"data-node-index":10}}}],"position":{"start":{"line":30,"column":1},"end":{"line":30,"column":67},"indent":[]},"index":9,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-projects-can-be-required-like-any-commonjs-document","data-node-index":9}},"id":"skypager-projects-can-be-required-like-any-commonjs-document","value":"Skypager Projects can be required like any common.js document","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.should.have.property('uri')\nproject.should.have.property('dirname', 'documentation')","position":{"start":{"line":32,"column":1},"end":{"line":35,"column":4},"indent":[1,1,1]},"index":10,"depth":3,"parentId":"skypager-projects-can-be-required-like-any-commonjs-document","childIndex":0,"childId":"code-3-1","id":"skypager-projects-can-be-required-like-any-commonjs-document-code-3-1","data":{"htmlAttributes":{"data-node-index":10}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager reads a collection of files and turns them into javascript","position":{"start":{"line":37,"column":5},"end":{"line":37,"column":72},"indent":[]}}],"position":{"start":{"line":37,"column":1},"end":{"line":37,"column":73},"indent":[]},"index":11,"data":{"htmlAttributes":{"id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"}},"id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript","value":"Skypager reads a collection of files and turns them into javascript","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"Skypager projects have a special structure.  Different folders are used to store different types of files which serve a different purpose. ","position":{"start":{"line":39,"column":1},"end":{"line":39,"column":140},"indent":[]}}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":140},"indent":[]},"index":12,"depth":3,"parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript","childIndex":0,"childId":"p-3-1","id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript-p-3-1","data":{"htmlAttributes":{"data-node-index":12}}},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Assets","position":{"start":{"line":41,"column":6},"end":{"line":41,"column":12},"indent":[]}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":12},"indent":[]},"index":13,"data":{"htmlAttributes":{"id":"assets"}},"id":"assets","value":"Assets","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"paragraph","children":[{"type":"text","value":"We start with the project assets themselves which would be anything from markdown documents, static data sources in JSON, SVG Diagrams, excel spreadsheets: anything which can be read and parsed and turned into javascript data. ","position":{"start":{"line":43,"column":1},"end":{"line":43,"column":228},"indent":[]}}],"position":{"start":{"line":43,"column":1},"end":{"line":43,"column":228},"indent":[]},"index":14,"depth":4,"parentId":"assets","childIndex":0,"childId":"p-4-1","id":"assets-p-4-1","data":{"htmlAttributes":{"data-node-index":14}}},{"type":"code","lang":"javascript","value":"project.paths.should.have.property('assets')\nproject.paths.should.have.property('documents')\nproject.paths.should.have.property('data_sources')","position":{"start":{"line":45,"column":1},"end":{"line":49,"column":4},"indent":[1,1,1,1]},"index":15,"depth":4,"parentId":"assets","childIndex":1,"childId":"code-4-2","id":"assets-code-4-2","data":{"htmlAttributes":{"data-node-index":15}}},{"type":"paragraph","children":[{"type":"text","value":"These assets are available to the project as content which can be\ndirectly rendered on a website, in the most simplest case.  ","position":{"start":{"line":51,"column":1},"end":{"line":52,"column":61},"indent":[1]}}],"position":{"start":{"line":51,"column":1},"end":{"line":52,"column":61},"indent":[1]},"index":16,"depth":4,"parentId":"assets","childIndex":2,"childId":"p-4-3","id":"assets-p-4-3","data":{"htmlAttributes":{"data-node-index":16}}},{"type":"code","lang":"javascript","value":"project.content.documents.should.have.property('assets')\nproject.content.assets.should.have.property('assets')\nproject.content.data_sources.should.have.property('assets')","position":{"start":{"line":54,"column":1},"end":{"line":58,"column":4},"indent":[1,1,1,1]},"index":17,"depth":4,"parentId":"assets","childIndex":3,"childId":"code-4-4","id":"assets-code-4-4","data":{"htmlAttributes":{"data-node-index":17}}},{"type":"paragraph","children":[{"type":"text","value":"However it is when we parse these things and use them to power our entity models, that we can do really interesting things with them.  The helper system allows us to define the way this content can be used to power these kinds of applications. ","position":{"start":{"line":60,"column":1},"end":{"line":60,"column":245},"indent":[]}}],"position":{"start":{"line":60,"column":1},"end":{"line":60,"column":245},"indent":[]},"index":18,"depth":4,"parentId":"assets","childIndex":4,"childId":"p-4-5","id":"assets-p-4-5","data":{"htmlAttributes":{"data-node-index":18}}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":12},"indent":[]},"index":13,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"assets","data-node-index":13}},"id":"assets","value":"Assets","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Helpers","position":{"start":{"line":62,"column":6},"end":{"line":62,"column":13},"indent":[]}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":13},"indent":[]},"index":19,"data":{"htmlAttributes":{"id":"helpers"}},"id":"helpers","value":"Helpers","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"paragraph","children":[{"type":"text","value":"Helpers are different types of javascript files which an be used to\nextend the functionality of a Skypager Project, control how it is\nrendered, how it can observe or interact with the outside world to keep\nthe different Entities referred to in the project in sync. ","position":{"start":{"line":64,"column":1},"end":{"line":67,"column":60},"indent":[1,1,1]}}],"position":{"start":{"line":64,"column":1},"end":{"line":67,"column":60},"indent":[1,1,1]},"index":20,"depth":4,"parentId":"helpers","childIndex":0,"childId":"p-4-1","id":"helpers-p-4-1","data":{"htmlAttributes":{"data-node-index":20}}},{"type":"paragraph","children":[{"type":"text","value":"A project can include its own custom helpers directly.","position":{"start":{"line":69,"column":1},"end":{"line":69,"column":55},"indent":[]}}],"position":{"start":{"line":69,"column":1},"end":{"line":69,"column":55},"indent":[]},"index":21,"depth":4,"parentId":"helpers","childIndex":1,"childId":"p-4-2","id":"helpers-p-4-2","data":{"htmlAttributes":{"data-node-index":21}}},{"type":"code","lang":"javascript","value":"project.paths.should.have.property('actions')\nproject.paths.should.have.property('exporters')\nproject.paths.should.have.property('importers')\nproject.paths.should.have.property('models')\nproject.paths.should.have.property('plugins')\nproject.paths.should.have.property('renderers')","position":{"start":{"line":71,"column":1},"end":{"line":78,"column":4},"indent":[1,1,1,1,1,1,1]},"index":22,"depth":4,"parentId":"helpers","childIndex":2,"childId":"code-4-3","id":"helpers-code-4-3","data":{"htmlAttributes":{"data-node-index":22}}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":13},"indent":[]},"index":19,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"helpers","data-node-index":19}},"id":"helpers","value":"Helpers","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"}],"position":{"start":{"line":37,"column":1},"end":{"line":37,"column":73},"indent":[]},"index":11,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript","data-node-index":11}},"id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript","value":"Skypager reads a collection of files and turns them into javascript","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"Skypager projects have a special structure.  Different folders are used to store different types of files which serve a different purpose. ","position":{"start":{"line":39,"column":1},"end":{"line":39,"column":140},"indent":[]}}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":140},"indent":[]},"index":12,"depth":3,"parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript","childIndex":0,"childId":"p-3-1","id":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript-p-3-1","data":{"htmlAttributes":{"data-node-index":12}}},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Assets","position":{"start":{"line":41,"column":6},"end":{"line":41,"column":12},"indent":[]}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":12},"indent":[]},"index":13,"data":{"htmlAttributes":{"id":"assets"}},"id":"assets","value":"Assets","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"paragraph","children":[{"type":"text","value":"We start with the project assets themselves which would be anything from markdown documents, static data sources in JSON, SVG Diagrams, excel spreadsheets: anything which can be read and parsed and turned into javascript data. ","position":{"start":{"line":43,"column":1},"end":{"line":43,"column":228},"indent":[]}}],"position":{"start":{"line":43,"column":1},"end":{"line":43,"column":228},"indent":[]},"index":14,"depth":4,"parentId":"assets","childIndex":0,"childId":"p-4-1","id":"assets-p-4-1","data":{"htmlAttributes":{"data-node-index":14}}},{"type":"code","lang":"javascript","value":"project.paths.should.have.property('assets')\nproject.paths.should.have.property('documents')\nproject.paths.should.have.property('data_sources')","position":{"start":{"line":45,"column":1},"end":{"line":49,"column":4},"indent":[1,1,1,1]},"index":15,"depth":4,"parentId":"assets","childIndex":1,"childId":"code-4-2","id":"assets-code-4-2","data":{"htmlAttributes":{"data-node-index":15}}},{"type":"paragraph","children":[{"type":"text","value":"These assets are available to the project as content which can be\ndirectly rendered on a website, in the most simplest case.  ","position":{"start":{"line":51,"column":1},"end":{"line":52,"column":61},"indent":[1]}}],"position":{"start":{"line":51,"column":1},"end":{"line":52,"column":61},"indent":[1]},"index":16,"depth":4,"parentId":"assets","childIndex":2,"childId":"p-4-3","id":"assets-p-4-3","data":{"htmlAttributes":{"data-node-index":16}}},{"type":"code","lang":"javascript","value":"project.content.documents.should.have.property('assets')\nproject.content.assets.should.have.property('assets')\nproject.content.data_sources.should.have.property('assets')","position":{"start":{"line":54,"column":1},"end":{"line":58,"column":4},"indent":[1,1,1,1]},"index":17,"depth":4,"parentId":"assets","childIndex":3,"childId":"code-4-4","id":"assets-code-4-4","data":{"htmlAttributes":{"data-node-index":17}}},{"type":"paragraph","children":[{"type":"text","value":"However it is when we parse these things and use them to power our entity models, that we can do really interesting things with them.  The helper system allows us to define the way this content can be used to power these kinds of applications. ","position":{"start":{"line":60,"column":1},"end":{"line":60,"column":245},"indent":[]}}],"position":{"start":{"line":60,"column":1},"end":{"line":60,"column":245},"indent":[]},"index":18,"depth":4,"parentId":"assets","childIndex":4,"childId":"p-4-5","id":"assets-p-4-5","data":{"htmlAttributes":{"data-node-index":18}}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":12},"indent":[]},"index":13,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"assets","data-node-index":13}},"id":"assets","value":"Assets","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"paragraph","children":[{"type":"text","value":"We start with the project assets themselves which would be anything from markdown documents, static data sources in JSON, SVG Diagrams, excel spreadsheets: anything which can be read and parsed and turned into javascript data. ","position":{"start":{"line":43,"column":1},"end":{"line":43,"column":228},"indent":[]}}],"position":{"start":{"line":43,"column":1},"end":{"line":43,"column":228},"indent":[]},"index":14,"depth":4,"parentId":"assets","childIndex":0,"childId":"p-4-1","id":"assets-p-4-1","data":{"htmlAttributes":{"data-node-index":14}}},{"type":"code","lang":"javascript","value":"project.paths.should.have.property('assets')\nproject.paths.should.have.property('documents')\nproject.paths.should.have.property('data_sources')","position":{"start":{"line":45,"column":1},"end":{"line":49,"column":4},"indent":[1,1,1,1]},"index":15,"depth":4,"parentId":"assets","childIndex":1,"childId":"code-4-2","id":"assets-code-4-2","data":{"htmlAttributes":{"data-node-index":15}}},{"type":"paragraph","children":[{"type":"text","value":"These assets are available to the project as content which can be\ndirectly rendered on a website, in the most simplest case.  ","position":{"start":{"line":51,"column":1},"end":{"line":52,"column":61},"indent":[1]}}],"position":{"start":{"line":51,"column":1},"end":{"line":52,"column":61},"indent":[1]},"index":16,"depth":4,"parentId":"assets","childIndex":2,"childId":"p-4-3","id":"assets-p-4-3","data":{"htmlAttributes":{"data-node-index":16}}},{"type":"code","lang":"javascript","value":"project.content.documents.should.have.property('assets')\nproject.content.assets.should.have.property('assets')\nproject.content.data_sources.should.have.property('assets')","position":{"start":{"line":54,"column":1},"end":{"line":58,"column":4},"indent":[1,1,1,1]},"index":17,"depth":4,"parentId":"assets","childIndex":3,"childId":"code-4-4","id":"assets-code-4-4","data":{"htmlAttributes":{"data-node-index":17}}},{"type":"paragraph","children":[{"type":"text","value":"However it is when we parse these things and use them to power our entity models, that we can do really interesting things with them.  The helper system allows us to define the way this content can be used to power these kinds of applications. ","position":{"start":{"line":60,"column":1},"end":{"line":60,"column":245},"indent":[]}}],"position":{"start":{"line":60,"column":1},"end":{"line":60,"column":245},"indent":[]},"index":18,"depth":4,"parentId":"assets","childIndex":4,"childId":"p-4-5","id":"assets-p-4-5","data":{"htmlAttributes":{"data-node-index":18}}},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Helpers","position":{"start":{"line":62,"column":6},"end":{"line":62,"column":13},"indent":[]}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":13},"indent":[]},"index":19,"data":{"htmlAttributes":{"id":"helpers"}},"id":"helpers","value":"Helpers","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"paragraph","children":[{"type":"text","value":"Helpers are different types of javascript files which an be used to\nextend the functionality of a Skypager Project, control how it is\nrendered, how it can observe or interact with the outside world to keep\nthe different Entities referred to in the project in sync. ","position":{"start":{"line":64,"column":1},"end":{"line":67,"column":60},"indent":[1,1,1]}}],"position":{"start":{"line":64,"column":1},"end":{"line":67,"column":60},"indent":[1,1,1]},"index":20,"depth":4,"parentId":"helpers","childIndex":0,"childId":"p-4-1","id":"helpers-p-4-1","data":{"htmlAttributes":{"data-node-index":20}}},{"type":"paragraph","children":[{"type":"text","value":"A project can include its own custom helpers directly.","position":{"start":{"line":69,"column":1},"end":{"line":69,"column":55},"indent":[]}}],"position":{"start":{"line":69,"column":1},"end":{"line":69,"column":55},"indent":[]},"index":21,"depth":4,"parentId":"helpers","childIndex":1,"childId":"p-4-2","id":"helpers-p-4-2","data":{"htmlAttributes":{"data-node-index":21}}},{"type":"code","lang":"javascript","value":"project.paths.should.have.property('actions')\nproject.paths.should.have.property('exporters')\nproject.paths.should.have.property('importers')\nproject.paths.should.have.property('models')\nproject.paths.should.have.property('plugins')\nproject.paths.should.have.property('renderers')","position":{"start":{"line":71,"column":1},"end":{"line":78,"column":4},"indent":[1,1,1,1,1,1,1]},"index":22,"depth":4,"parentId":"helpers","childIndex":2,"childId":"code-4-3","id":"helpers-code-4-3","data":{"htmlAttributes":{"data-node-index":22}}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":13},"indent":[]},"index":19,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"helpers","data-node-index":19}},"id":"helpers","value":"Helpers","parentId":"skypager-reads-a-collection-of-files-and-turns-them-into-javascript"},{"type":"paragraph","children":[{"type":"text","value":"Helpers are different types of javascript files which an be used to\nextend the functionality of a Skypager Project, control how it is\nrendered, how it can observe or interact with the outside world to keep\nthe different Entities referred to in the project in sync. ","position":{"start":{"line":64,"column":1},"end":{"line":67,"column":60},"indent":[1,1,1]}}],"position":{"start":{"line":64,"column":1},"end":{"line":67,"column":60},"indent":[1,1,1]},"index":20,"depth":4,"parentId":"helpers","childIndex":0,"childId":"p-4-1","id":"helpers-p-4-1","data":{"htmlAttributes":{"data-node-index":20}}},{"type":"paragraph","children":[{"type":"text","value":"A project can include its own custom helpers directly.","position":{"start":{"line":69,"column":1},"end":{"line":69,"column":55},"indent":[]}}],"position":{"start":{"line":69,"column":1},"end":{"line":69,"column":55},"indent":[]},"index":21,"depth":4,"parentId":"helpers","childIndex":1,"childId":"p-4-2","id":"helpers-p-4-2","data":{"htmlAttributes":{"data-node-index":21}}},{"type":"code","lang":"javascript","value":"project.paths.should.have.property('actions')\nproject.paths.should.have.property('exporters')\nproject.paths.should.have.property('importers')\nproject.paths.should.have.property('models')\nproject.paths.should.have.property('plugins')\nproject.paths.should.have.property('renderers')","position":{"start":{"line":71,"column":1},"end":{"line":78,"column":4},"indent":[1,1,1,1,1,1,1]},"index":22,"depth":4,"parentId":"helpers","childIndex":2,"childId":"code-4-3","id":"helpers-code-4-3","data":{"htmlAttributes":{"data-node-index":22}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager ships with a few of its own helpers","position":{"start":{"line":79,"column":5},"end":{"line":79,"column":49},"indent":[]}}],"position":{"start":{"line":79,"column":1},"end":{"line":79,"column":49},"indent":[]},"index":23,"data":{"htmlAttributes":{"id":"skypager-ships-with-a-few-of-its-own-helpers"}},"id":"skypager-ships-with-a-few-of-its-own-helpers","value":"Skypager ships with a few of its own helpers","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"Skypager also ships with a bunch of its own helpers for common use cases.","position":{"start":{"line":81,"column":1},"end":{"line":81,"column":74},"indent":[]}}],"position":{"start":{"line":81,"column":1},"end":{"line":81,"column":74},"indent":[]},"index":24,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-helpers","childIndex":0,"childId":"p-3-1","id":"skypager-ships-with-a-few-of-its-own-helpers-p-3-1","data":{"htmlAttributes":{"data-node-index":24}}},{"type":"paragraph","children":[{"type":"text","value":"Using helpers internally is a clean way of organizing the many different\nparts of our code base.","position":{"start":{"line":83,"column":1},"end":{"line":84,"column":24},"indent":[1]}}],"position":{"start":{"line":83,"column":1},"end":{"line":84,"column":24},"indent":[1]},"index":25,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-helpers","childIndex":1,"childId":"p-3-2","id":"skypager-ships-with-a-few-of-its-own-helpers-p-3-2","data":{"htmlAttributes":{"data-node-index":25}}},{"type":"code","lang":"javascript","value":"skypager.helpers.exporters.assets.should.not.have.property('length',0)\nskypager.helpers.importers.assets.should.not.have.property('length',0)\nskypager.helpers.models.assets.should.not.have.property('length',0)\nskypager.helpers.renderers.assets.should.not.have.property('length',0)","position":{"start":{"line":86,"column":1},"end":{"line":91,"column":4},"indent":[1,1,1,1,1]},"index":26,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-helpers","childIndex":2,"childId":"code-3-3","id":"skypager-ships-with-a-few-of-its-own-helpers-code-3-3","data":{"htmlAttributes":{"data-node-index":26}}}],"position":{"start":{"line":79,"column":1},"end":{"line":79,"column":49},"indent":[]},"index":23,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-ships-with-a-few-of-its-own-helpers","data-node-index":23}},"id":"skypager-ships-with-a-few-of-its-own-helpers","value":"Skypager ships with a few of its own helpers","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"Skypager also ships with a bunch of its own helpers for common use cases.","position":{"start":{"line":81,"column":1},"end":{"line":81,"column":74},"indent":[]}}],"position":{"start":{"line":81,"column":1},"end":{"line":81,"column":74},"indent":[]},"index":24,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-helpers","childIndex":0,"childId":"p-3-1","id":"skypager-ships-with-a-few-of-its-own-helpers-p-3-1","data":{"htmlAttributes":{"data-node-index":24}}},{"type":"paragraph","children":[{"type":"text","value":"Using helpers internally is a clean way of organizing the many different\nparts of our code base.","position":{"start":{"line":83,"column":1},"end":{"line":84,"column":24},"indent":[1]}}],"position":{"start":{"line":83,"column":1},"end":{"line":84,"column":24},"indent":[1]},"index":25,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-helpers","childIndex":1,"childId":"p-3-2","id":"skypager-ships-with-a-few-of-its-own-helpers-p-3-2","data":{"htmlAttributes":{"data-node-index":25}}},{"type":"code","lang":"javascript","value":"skypager.helpers.exporters.assets.should.not.have.property('length',0)\nskypager.helpers.importers.assets.should.not.have.property('length',0)\nskypager.helpers.models.assets.should.not.have.property('length',0)\nskypager.helpers.renderers.assets.should.not.have.property('length',0)","position":{"start":{"line":86,"column":1},"end":{"line":91,"column":4},"indent":[1,1,1,1,1]},"index":26,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-helpers","childIndex":2,"childId":"code-3-3","id":"skypager-ships-with-a-few-of-its-own-helpers-code-3-3","data":{"htmlAttributes":{"data-node-index":26}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager ships with a few of its own plugins.","position":{"start":{"line":93,"column":5},"end":{"line":93,"column":50},"indent":[]}}],"position":{"start":{"line":93,"column":1},"end":{"line":93,"column":50},"indent":[]},"index":27,"data":{"htmlAttributes":{"id":"skypager-ships-with-a-few-of-its-own-plugins"}},"id":"skypager-ships-with-a-few-of-its-own-plugins","value":"Skypager ships with a few of its own plugins.","parentId":"specifications"},{"type":"code","lang":"javascript","value":"skypager.helpers.plugins.should.have.property('assets')\nskypager.helpers.plugins.assets.should.not.have.property('length',0)","position":{"start":{"line":95,"column":1},"end":{"line":98,"column":4},"indent":[1,1,1]},"index":28,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-plugins","childIndex":0,"childId":"code-3-1","id":"skypager-ships-with-a-few-of-its-own-plugins-code-3-1","data":{"htmlAttributes":{"data-node-index":28}}},{"type":"paragraph","children":[{"type":"text","value":"These can be used by any project, and provide additional helpers.","position":{"start":{"line":100,"column":1},"end":{"line":100,"column":66},"indent":[]}}],"position":{"start":{"line":100,"column":1},"end":{"line":100,"column":66},"indent":[]},"index":29,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-plugins","childIndex":1,"childId":"p-3-2","id":"skypager-ships-with-a-few-of-its-own-plugins-p-3-2","data":{"htmlAttributes":{"data-node-index":29}}}],"position":{"start":{"line":93,"column":1},"end":{"line":93,"column":50},"indent":[]},"index":27,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-ships-with-a-few-of-its-own-plugins","data-node-index":27}},"id":"skypager-ships-with-a-few-of-its-own-plugins","value":"Skypager ships with a few of its own plugins.","parentId":"specifications"},{"type":"code","lang":"javascript","value":"skypager.helpers.plugins.should.have.property('assets')\nskypager.helpers.plugins.assets.should.not.have.property('length',0)","position":{"start":{"line":95,"column":1},"end":{"line":98,"column":4},"indent":[1,1,1]},"index":28,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-plugins","childIndex":0,"childId":"code-3-1","id":"skypager-ships-with-a-few-of-its-own-plugins-code-3-1","data":{"htmlAttributes":{"data-node-index":28}}},{"type":"paragraph","children":[{"type":"text","value":"These can be used by any project, and provide additional helpers.","position":{"start":{"line":100,"column":1},"end":{"line":100,"column":66},"indent":[]}}],"position":{"start":{"line":100,"column":1},"end":{"line":100,"column":66},"indent":[]},"index":29,"depth":3,"parentId":"skypager-ships-with-a-few-of-its-own-plugins","childIndex":1,"childId":"p-3-2","id":"skypager-ships-with-a-few-of-its-own-plugins-p-3-2","data":{"htmlAttributes":{"data-node-index":29}}}],"position":{"start":{"line":1,"column":1},"end":{"line":103,"column":1}}},"indexes":{"ids":{"index-yaml-1-1":0,"skypagerjs":1,"skypagerjs-p-1-1":2,"skypagerjs-p-1-2":3,"skypagerjs-p-1-3":4,"setup":5,"setup-p-2-1":6,"setup-p-2-2":7,"specifications":8,"skypager-projects-can-be-required-like-any-commonjs-document":9,"skypager-projects-can-be-required-like-any-commonjs-document-code-3-1":10,"skypager-reads-a-collection-of-files-and-turns-them-into-javascript":11,"skypager-reads-a-collection-of-files-and-turns-them-into-javascript-p-3-1":12,"assets":13,"assets-p-4-1":14,"assets-code-4-2":15,"assets-p-4-3":16,"assets-code-4-4":17,"assets-p-4-5":18,"helpers":19,"helpers-p-4-1":20,"helpers-p-4-2":21,"helpers-code-4-3":22,"skypager-ships-with-a-few-of-its-own-helpers":23,"skypager-ships-with-a-few-of-its-own-helpers-p-3-1":24,"skypager-ships-with-a-few-of-its-own-helpers-p-3-2":25,"skypager-ships-with-a-few-of-its-own-helpers-code-3-3":26,"skypager-ships-with-a-few-of-its-own-plugins":27,"skypager-ships-with-a-few-of-its-own-plugins-code-3-1":28,"skypager-ships-with-a-few-of-its-own-plugins-p-3-2":29},"depths":{"1":[1],"2":[5,8],"3":[9,11,23,27],"4":[13,19],"5":[],"6":[]},"types":{"yaml":[0],"heading":[1,5,8,9,11,13,19,23,27],"paragraph":[2,3,4,6,7,12,14,16,18,20,21,24,25,29],"code":[10,15,17,22,26,28]},"childrenIndexes":{"index":[0,1],"skypagerjs":[2,3,4,5,8],"setup":[6,7],"specifications":[9,11,23,27],"skypager-projects-can-be-required-like-any-commonjs-document":[10],"skypager-reads-a-collection-of-files-and-turns-them-into-javascript":[12,13,19],"assets":[14,15,16,17,18],"helpers":[20,21,22],"skypager-ships-with-a-few-of-its-own-helpers":[24,25,26],"skypager-ships-with-a-few-of-its-own-plugins":[28,29]}},"html":"<main id=\"index\" class=\"skypager-document \"><h1 id=\"skypagerjs\" data-node-index=\"1\">Skypager.js</h1><p data-node-index=\"2\">Welcome to the documentation and test suite for Skypager which I\nlike to call the cloud writing framework.  Skypager makes it easy to\nbuild data driven reactive websites on top of the many forms of constantly\nevolving streams of communication that humans engage in on the internet.</p><p data-node-index=\"3\">A Skypager project contains writing about certain abstract set of Things, or more formally Entities.  These entities usually exist in or are referred to by some other document, system, or external API.  A lot of the time these Entities may change over time.</p><p data-node-index=\"4\">Skypager provides an easy way for building functionality around these entities and their relationships to each other, and to incorporate other knowledge data related to these Entities in that exist in other systems.</p><section class=\"depth-2 sections\" id=\"setup\" data-node-index=\"5\"><h2 id=\"setup\">Setup</h2><p data-node-index=\"6\">If you are reading this page, this has been generated by Skypager.  It\nconsists of individual markdown files that correspond to important areas\nof the project&apos;s internals.  These markdown files follow a particular\nstructure with respect to the headings they use. This allows us to parse\ntheir contents and use them to build more dynamic and interactive web\ncontent than we would be able to with just traditional markdown.</p><p data-node-index=\"7\">This documentation is both API documentation for the project and runnable test code.</p></section><section class=\"depth-2 sections\" id=\"specifications\" data-node-index=\"8\"><h2 id=\"specifications\">Specifications</h2><article class=\"depth-3 articles\" id=\"skypager-projects-can-be-required-like-any-commonjs-document\" data-node-index=\"9\"><h3 id=\"skypager-projects-can-be-required-like-any-commonjs-document\">Skypager Projects can be required like any common.js document</h3><pre><code data-node-index=\"10\">project.should.have.property(&apos;uri&apos;)\nproject.should.have.property(&apos;dirname&apos;, &apos;documentation&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"skypager-reads-a-collection-of-files-and-turns-them-into-javascript\" data-node-index=\"11\"><h3 id=\"skypager-reads-a-collection-of-files-and-turns-them-into-javascript\">Skypager reads a collection of files and turns them into javascript</h3><p data-node-index=\"12\">Skypager projects have a special structure.  Different folders are used to store different types of files which serve a different purpose.</p><div class=\"depth-4\" id=\"assets\" data-node-index=\"13\"><h4 id=\"assets\">Assets</h4><p data-node-index=\"14\">We start with the project assets themselves which would be anything from markdown documents, static data sources in JSON, SVG Diagrams, excel spreadsheets: anything which can be read and parsed and turned into javascript data.</p><pre><code data-node-index=\"15\">project.paths.should.have.property(&apos;assets&apos;)\nproject.paths.should.have.property(&apos;documents&apos;)\nproject.paths.should.have.property(&apos;data_sources&apos;)\n</code></pre><p data-node-index=\"16\">These assets are available to the project as content which can be\ndirectly rendered on a website, in the most simplest case.</p><pre><code data-node-index=\"17\">project.content.documents.should.have.property(&apos;assets&apos;)\nproject.content.assets.should.have.property(&apos;assets&apos;)\nproject.content.data_sources.should.have.property(&apos;assets&apos;)\n</code></pre><p data-node-index=\"18\">However it is when we parse these things and use them to power our entity models, that we can do really interesting things with them.  The helper system allows us to define the way this content can be used to power these kinds of applications.</p></div><div class=\"depth-4\" id=\"helpers\" data-node-index=\"19\"><h4 id=\"helpers\">Helpers</h4><p data-node-index=\"20\">Helpers are different types of javascript files which an be used to\nextend the functionality of a Skypager Project, control how it is\nrendered, how it can observe or interact with the outside world to keep\nthe different Entities referred to in the project in sync.</p><p data-node-index=\"21\">A project can include its own custom helpers directly.</p><pre><code data-node-index=\"22\">project.paths.should.have.property(&apos;actions&apos;)\nproject.paths.should.have.property(&apos;exporters&apos;)\nproject.paths.should.have.property(&apos;importers&apos;)\nproject.paths.should.have.property(&apos;models&apos;)\nproject.paths.should.have.property(&apos;plugins&apos;)\nproject.paths.should.have.property(&apos;renderers&apos;)\n</code></pre></div></article><article class=\"depth-3 articles\" id=\"skypager-ships-with-a-few-of-its-own-helpers\" data-node-index=\"23\"><h3 id=\"skypager-ships-with-a-few-of-its-own-helpers\">Skypager ships with a few of its own helpers</h3><p data-node-index=\"24\">Skypager also ships with a bunch of its own helpers for common use cases.</p><p data-node-index=\"25\">Using helpers internally is a clean way of organizing the many different\nparts of our code base.</p><pre><code data-node-index=\"26\">skypager.helpers.exporters.assets.should.not.have.property(&apos;length&apos;,0)\nskypager.helpers.importers.assets.should.not.have.property(&apos;length&apos;,0)\nskypager.helpers.models.assets.should.not.have.property(&apos;length&apos;,0)\nskypager.helpers.renderers.assets.should.not.have.property(&apos;length&apos;,0)\n</code></pre></article><article class=\"depth-3 articles\" id=\"skypager-ships-with-a-few-of-its-own-plugins\" data-node-index=\"27\"><h3 id=\"skypager-ships-with-a-few-of-its-own-plugins\">Skypager ships with a few of its own plugins.</h3><pre><code data-node-index=\"28\">skypager.helpers.plugins.should.have.property(&apos;assets&apos;)\nskypager.helpers.plugins.assets.should.not.have.property(&apos;length&apos;,0)\n</code></pre><p data-node-index=\"29\">These can be used by any project, and provide additional helpers.</p></article></section></main>\n"};