module.exports = {"id":"testcases/resolvers/model-resolver-spec","paths":{"relative":"testcases/resolvers/model-resolver-spec.md","project":"docs/testcases/resolvers/model-resolver-spec.md","projectRequire":"docs/testcases/resolvers/model-resolver-spec.md","absolute":"/Users/jonathan/Skypager/packages/skypager-project/test/fixture/docs/testcases/resolvers/model-resolver-spec.md"},"assetGroup":"documents","fingerprint":"24c6f05bb8a9e3dbf4adc3dce73396aa","markdown":"# Model Resolver Spec\n\nGenerally Skypager Projects follow a convention over configuration philosophy and we can deduce through which folder something is in, or what it is named, what helpers are responsible for that file.\n\nHowever in the event you wanted to deviate from this, resolvers can be used to help determine things like which Model class should be responsible for turning a Document into an Entity.\n\n## Specifications\n\n### Projects can set a default model class\n\n```\nproject.models.default.should.have.property.name('Testcase')\n```\n\n### Documents can set a type value in their metadata to control which model is used\n\n### The folders directly under the projects documents paths are named like their models \n\n```\nproject.resolve.model('docs/examples').should.have.property.name('Example')\n```\n\n### Projects can be configured with regular expressions to map to a particular model\n\n```\nproject.resolve.models.addPattern(/-spec.js$/, 'testcase')\nproject.resolve.model('whatever-spec.js').should.have.property.name('Testcase')\n```\n","ast":{"type":"root","children":[{"type":"heading","depth":1,"children":[{"type":"text","value":"Model Resolver Spec","position":{"start":{"line":1,"column":3},"end":{"line":1,"column":22},"indent":[]}}],"position":{"start":{"line":1,"column":1},"end":{"line":1,"column":22},"indent":[]},"index":0,"data":{"htmlAttributes":{"id":"model-resolver-spec","data-node-index":0}},"id":"model-resolver-spec","value":"Model Resolver Spec","parentId":"testcases__resolvers__model-resolver-spec"},{"type":"paragraph","children":[{"type":"text","value":"Generally Skypager Projects follow a convention over configuration philosophy and we can deduce through which folder something is in, or what it is named, what helpers are responsible for that file.","position":{"start":{"line":3,"column":1},"end":{"line":3,"column":199},"indent":[]}}],"position":{"start":{"line":3,"column":1},"end":{"line":3,"column":199},"indent":[]},"index":1,"depth":1,"parentId":"model-resolver-spec","childIndex":0,"childId":"p-1-1","id":"model-resolver-spec-p-1-1","data":{"htmlAttributes":{"data-node-index":1}}},{"type":"paragraph","children":[{"type":"text","value":"However in the event you wanted to deviate from this, resolvers can be used to help determine things like which Model class should be responsible for turning a Document into an Entity.","position":{"start":{"line":5,"column":1},"end":{"line":5,"column":185},"indent":[]}}],"position":{"start":{"line":5,"column":1},"end":{"line":5,"column":185},"indent":[]},"index":2,"depth":1,"parentId":"model-resolver-spec","childIndex":1,"childId":"p-1-2","id":"model-resolver-spec-p-1-2","data":{"htmlAttributes":{"data-node-index":2}}},{"type":"section","depth":2,"children":[{"type":"heading","depth":2,"children":[{"type":"text","value":"Specifications","position":{"start":{"line":7,"column":4},"end":{"line":7,"column":18},"indent":[]}}],"position":{"start":{"line":7,"column":1},"end":{"line":7,"column":18},"indent":[]},"index":3,"data":{"htmlAttributes":{"id":"specifications"}},"id":"specifications","value":"Specifications","parentId":"model-resolver-spec"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Projects can set a default model class","position":{"start":{"line":9,"column":5},"end":{"line":9,"column":43},"indent":[]}}],"position":{"start":{"line":9,"column":1},"end":{"line":9,"column":43},"indent":[]},"index":4,"data":{"htmlAttributes":{"id":"projects-can-set-a-default-model-class"}},"id":"projects-can-set-a-default-model-class","value":"Projects can set a default model class","parentId":"specifications"},{"type":"code","lang":null,"value":"project.models.default.should.have.property.name('Testcase')","position":{"start":{"line":11,"column":1},"end":{"line":13,"column":4},"indent":[1,1]},"index":5,"depth":3,"parentId":"projects-can-set-a-default-model-class","childIndex":0,"childId":"code-3-1","id":"projects-can-set-a-default-model-class-code-3-1","data":{"htmlAttributes":{"data-node-index":5}}}],"position":{"start":{"line":9,"column":1},"end":{"line":9,"column":43},"indent":[]},"index":4,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"projects-can-set-a-default-model-class","data-node-index":4}},"id":"projects-can-set-a-default-model-class","value":"Projects can set a default model class","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Documents can set a type value in their metadata to control which model is used","position":{"start":{"line":15,"column":5},"end":{"line":15,"column":84},"indent":[]}}],"position":{"start":{"line":15,"column":1},"end":{"line":15,"column":84},"indent":[]},"index":6,"data":{"htmlAttributes":{"id":"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used"}},"id":"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used","value":"Documents can set a type value in their metadata to control which model is used","parentId":"specifications"}],"position":{"start":{"line":15,"column":1},"end":{"line":15,"column":84},"indent":[]},"index":6,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used","data-node-index":6}},"id":"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used","value":"Documents can set a type value in their metadata to control which model is used","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"The folders directly under the projects documents paths are named like their models","position":{"start":{"line":17,"column":5},"end":{"line":17,"column":88},"indent":[]}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":89},"indent":[]},"index":7,"data":{"htmlAttributes":{"id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models"}},"id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models","value":"The folders directly under the projects documents paths are named like their models","parentId":"specifications"},{"type":"code","lang":null,"value":"project.resolve.model('docs/examples').should.have.property.name('Example')","position":{"start":{"line":19,"column":1},"end":{"line":21,"column":4},"indent":[1,1]},"index":8,"depth":3,"parentId":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models","childIndex":0,"childId":"code-3-1","id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models-code-3-1","data":{"htmlAttributes":{"data-node-index":8}}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":89},"indent":[]},"index":7,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models","data-node-index":7}},"id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models","value":"The folders directly under the projects documents paths are named like their models","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Projects can be configured with regular expressions to map to a particular model","position":{"start":{"line":23,"column":5},"end":{"line":23,"column":85},"indent":[]}}],"position":{"start":{"line":23,"column":1},"end":{"line":23,"column":85},"indent":[]},"index":9,"data":{"htmlAttributes":{"id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model"}},"id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model","value":"Projects can be configured with regular expressions to map to a particular model","parentId":"specifications"},{"type":"code","lang":null,"value":"project.resolve.models.addPattern(/-spec.js$/, 'testcase')\nproject.resolve.model('whatever-spec.js').should.have.property.name('Testcase')","position":{"start":{"line":25,"column":1},"end":{"line":28,"column":4},"indent":[1,1,1]},"index":10,"depth":3,"parentId":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model","childIndex":0,"childId":"code-3-1","id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model-code-3-1","data":{"htmlAttributes":{"data-node-index":10}}}],"position":{"start":{"line":23,"column":1},"end":{"line":23,"column":85},"indent":[]},"index":9,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model","data-node-index":9}},"id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model","value":"Projects can be configured with regular expressions to map to a particular model","parentId":"specifications"}],"position":{"start":{"line":7,"column":1},"end":{"line":7,"column":18},"indent":[]},"index":3,"data":{"htmlName":"section","htmlAttributes":{"class":"depth-2 sections","id":"specifications","data-node-index":3}},"id":"specifications","value":"Specifications","parentId":"model-resolver-spec"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Projects can set a default model class","position":{"start":{"line":9,"column":5},"end":{"line":9,"column":43},"indent":[]}}],"position":{"start":{"line":9,"column":1},"end":{"line":9,"column":43},"indent":[]},"index":4,"data":{"htmlAttributes":{"id":"projects-can-set-a-default-model-class"}},"id":"projects-can-set-a-default-model-class","value":"Projects can set a default model class","parentId":"specifications"},{"type":"code","lang":null,"value":"project.models.default.should.have.property.name('Testcase')","position":{"start":{"line":11,"column":1},"end":{"line":13,"column":4},"indent":[1,1]},"index":5,"depth":3,"parentId":"projects-can-set-a-default-model-class","childIndex":0,"childId":"code-3-1","id":"projects-can-set-a-default-model-class-code-3-1","data":{"htmlAttributes":{"data-node-index":5}}}],"position":{"start":{"line":9,"column":1},"end":{"line":9,"column":43},"indent":[]},"index":4,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"projects-can-set-a-default-model-class","data-node-index":4}},"id":"projects-can-set-a-default-model-class","value":"Projects can set a default model class","parentId":"specifications"},{"type":"code","lang":null,"value":"project.models.default.should.have.property.name('Testcase')","position":{"start":{"line":11,"column":1},"end":{"line":13,"column":4},"indent":[1,1]},"index":5,"depth":3,"parentId":"projects-can-set-a-default-model-class","childIndex":0,"childId":"code-3-1","id":"projects-can-set-a-default-model-class-code-3-1","data":{"htmlAttributes":{"data-node-index":5}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Documents can set a type value in their metadata to control which model is used","position":{"start":{"line":15,"column":5},"end":{"line":15,"column":84},"indent":[]}}],"position":{"start":{"line":15,"column":1},"end":{"line":15,"column":84},"indent":[]},"index":6,"data":{"htmlAttributes":{"id":"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used"}},"id":"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used","value":"Documents can set a type value in their metadata to control which model is used","parentId":"specifications"}],"position":{"start":{"line":15,"column":1},"end":{"line":15,"column":84},"indent":[]},"index":6,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used","data-node-index":6}},"id":"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used","value":"Documents can set a type value in their metadata to control which model is used","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"The folders directly under the projects documents paths are named like their models","position":{"start":{"line":17,"column":5},"end":{"line":17,"column":88},"indent":[]}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":89},"indent":[]},"index":7,"data":{"htmlAttributes":{"id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models"}},"id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models","value":"The folders directly under the projects documents paths are named like their models","parentId":"specifications"},{"type":"code","lang":null,"value":"project.resolve.model('docs/examples').should.have.property.name('Example')","position":{"start":{"line":19,"column":1},"end":{"line":21,"column":4},"indent":[1,1]},"index":8,"depth":3,"parentId":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models","childIndex":0,"childId":"code-3-1","id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models-code-3-1","data":{"htmlAttributes":{"data-node-index":8}}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":89},"indent":[]},"index":7,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models","data-node-index":7}},"id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models","value":"The folders directly under the projects documents paths are named like their models","parentId":"specifications"},{"type":"code","lang":null,"value":"project.resolve.model('docs/examples').should.have.property.name('Example')","position":{"start":{"line":19,"column":1},"end":{"line":21,"column":4},"indent":[1,1]},"index":8,"depth":3,"parentId":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models","childIndex":0,"childId":"code-3-1","id":"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models-code-3-1","data":{"htmlAttributes":{"data-node-index":8}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Projects can be configured with regular expressions to map to a particular model","position":{"start":{"line":23,"column":5},"end":{"line":23,"column":85},"indent":[]}}],"position":{"start":{"line":23,"column":1},"end":{"line":23,"column":85},"indent":[]},"index":9,"data":{"htmlAttributes":{"id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model"}},"id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model","value":"Projects can be configured with regular expressions to map to a particular model","parentId":"specifications"},{"type":"code","lang":null,"value":"project.resolve.models.addPattern(/-spec.js$/, 'testcase')\nproject.resolve.model('whatever-spec.js').should.have.property.name('Testcase')","position":{"start":{"line":25,"column":1},"end":{"line":28,"column":4},"indent":[1,1,1]},"index":10,"depth":3,"parentId":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model","childIndex":0,"childId":"code-3-1","id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model-code-3-1","data":{"htmlAttributes":{"data-node-index":10}}}],"position":{"start":{"line":23,"column":1},"end":{"line":23,"column":85},"indent":[]},"index":9,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model","data-node-index":9}},"id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model","value":"Projects can be configured with regular expressions to map to a particular model","parentId":"specifications"},{"type":"code","lang":null,"value":"project.resolve.models.addPattern(/-spec.js$/, 'testcase')\nproject.resolve.model('whatever-spec.js').should.have.property.name('Testcase')","position":{"start":{"line":25,"column":1},"end":{"line":28,"column":4},"indent":[1,1,1]},"index":10,"depth":3,"parentId":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model","childIndex":0,"childId":"code-3-1","id":"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model-code-3-1","data":{"htmlAttributes":{"data-node-index":10}}}],"position":{"start":{"line":1,"column":1},"end":{"line":29,"column":1}}},"indexes":{"ids":{"model-resolver-spec":0,"model-resolver-spec-p-1-1":1,"model-resolver-spec-p-1-2":2,"specifications":3,"projects-can-set-a-default-model-class":4,"projects-can-set-a-default-model-class-code-3-1":5,"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used":6,"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models":7,"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models-code-3-1":8,"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model":9,"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model-code-3-1":10},"depths":{"1":[0],"2":[3],"3":[4,6,7,9],"4":[],"5":[],"6":[]},"types":{"heading":[0,3,4,6,7,9],"paragraph":[1,2],"code":[5,8,10]},"childrenIndexes":{"testcases__resolvers__model-resolver-spec":[0],"model-resolver-spec":[1,2,3],"specifications":[4,6,7,9],"projects-can-set-a-default-model-class":[5],"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models":[8],"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model":[10]}},"html":"<main id=\"testcases__resolvers__model-resolver-spec\" class=\"skypager-document testcases\"><h1 id=\"model-resolver-spec\" data-node-index=\"\">Model Resolver Spec</h1><p data-node-index=\"1\">Generally Skypager Projects follow a convention over configuration philosophy and we can deduce through which folder something is in, or what it is named, what helpers are responsible for that file.</p><p data-node-index=\"2\">However in the event you wanted to deviate from this, resolvers can be used to help determine things like which Model class should be responsible for turning a Document into an Entity.</p><section class=\"depth-2 sections\" id=\"specifications\" data-node-index=\"3\"><h2 id=\"specifications\">Specifications</h2><article class=\"depth-3 articles\" id=\"projects-can-set-a-default-model-class\" data-node-index=\"4\"><h3 id=\"projects-can-set-a-default-model-class\">Projects can set a default model class</h3><pre><code data-node-index=\"5\">project.models.default.should.have.property.name(&apos;Testcase&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used\" data-node-index=\"6\"><h3 id=\"documents-can-set-a-type-value-in-their-metadata-to-control-which-model-is-used\">Documents can set a type value in their metadata to control which model is used</h3></article><article class=\"depth-3 articles\" id=\"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models\" data-node-index=\"7\"><h3 id=\"the-folders-directly-under-the-projects-documents-paths-are-named-like-their-models\">The folders directly under the projects documents paths are named like their models</h3><pre><code data-node-index=\"8\">project.resolve.model(&apos;docs/examples&apos;).should.have.property.name(&apos;Example&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model\" data-node-index=\"9\"><h3 id=\"projects-can-be-configured-with-regular-expressions-to-map-to-a-particular-model\">Projects can be configured with regular expressions to map to a particular model</h3><pre><code data-node-index=\"10\">project.resolve.models.addPattern(/-spec.js$/, &apos;testcase&apos;)\nproject.resolve.model(&apos;whatever-spec.js&apos;).should.have.property.name(&apos;Testcase&apos;)\n</code></pre></article></section></main>\n"};